
#pragma once

#include "common.h"
#include "Console.h"

#define PLAYER_SIZE          5

class Player
{
private:
	int x;
	int y;	
	int LiveFlag;
	char PlayerUnit[PLAYER_SIZE + 1];
private:
	static Player* m_pInstance;
protected:
	Player();
public:
	static Player* GetInstance(void)
	{
		if ( m_pInstance == NULL )
			m_pInstance = new Player();

		return m_pInstance;
	}
public:
	~Player(){;}
	void Init(int _x, int _y);
	void SetPosition(int _x, int _y);
public:
	void SetX(int _x)			{	this->x = _x;	}
    void SetY(int _y)			{	this->y = _y;	}
	void SetLiveFlag(int _Flag) {LiveFlag = _Flag;  }
public:
	int GetX(void)          {   return x;        }
    int GetY(void)          {   return y;        }
    int GetLiveFlag(void)   {   return LiveFlag;	}
public:
	void DrawPlayer(void);
	void PlayerAction(void);
public:
	/*	총알과 플레이어의 간의 충돌 체크하는 함수	*/
	bool CollisionWithShot(int _shotX, int _shotY);
};

Player* Player::m_pInstance = NULL;

Player::Player()
{
	x = 0;
	y = 0;
	LiveFlag = 0;

	strcpy( this->PlayerUnit, "#-^-#" );
}

void Player::Init(int _x, int _y)
{
	this->SetPosition( _x, _y );

	LiveFlag = 1;
}

void Player::SetPosition(int _x, int _y)
{
	this->SetX( _x );
	this->SetY( _y );
}

void Player::DrawPlayer(void)
{
	int i;

	int LeftX = x - PLAYER_SIZE / 2;						
	
	if ( y < 0 || y >= HEIGHT ) 
		return;
	 
	for ( i = 0; i < PLAYER_SIZE; i++ ) 
	{
		if ( LeftX >= 0 && LeftX < WIDTH ) 
			Screen[y][LeftX] = PlayerUnit[i];
		
		LeftX++;
	}
}

void Player::PlayerAction(void)
{
	if ( GetAsyncKeyState(VK_UP) & 0x8000 ) 
	{
		y--;	
		if ( y < 0 )							
			y = 0;
	}
	if ( GetAsyncKeyState(VK_DOWN) & 0x8000 ) 
	{
		y++;	
		if ( y >= HEIGHT - 1 )					
			y = HEIGHT - 2;
	}
	if ( GetAsyncKeyState(VK_LEFT) & 0x8000 ) 
	{
		x -= 2;	
		if ( x < PLAYER_SIZE / 2 )		
			x = PLAYER_SIZE / 2;
	}

	if ( GetAsyncKeyState(VK_RIGHT) & 0x8000 ) 
	{
		x += 2;	
		if ( x >= WIDTH - 2 - PLAYER_SIZE / 2 )
			x = WIDTH - 2 - PLAYER_SIZE / 2;
	}
}

bool Player::CollisionWithShot(int _shotX, int _shotY)
{
	if ( _shotX >= x - PLAYER_SIZE / 2 && 
		 _shotX <= x + PLAYER_SIZE / 2 && _shotY == y 
	   ) 
	{	
		LiveFlag = 0;	
		return true;
	}
	return false;
}